# 调试记录

这里记录一些比较棘手的问题。

|问题|原因分析|解决方案|
|:--|:--|:--|
|编码后的声音有不合理的失真。具体现象是钢琴等乐器的声音呈现水钟样声音，等等，声谱图上可见某些谱线缺失或多余。|此问题并非量化失真，考虑是混合子带滤波有问题。|将现有代码逐行与dist10比对，发现dist10对分析子带滤波器的结果做了乘以-1的后处理。原因在于分析子带滤波的输入是反向的，需要对其输出作处理，才能得到正确的结果。目前不清楚这个性质的依据是什么。|
|码流有同步错误，EncSpot显示的帧数少于实际帧数。|比特流组装时，每个granule的每个声道都有各自独立的`part23length`，需要分别stuffing，然后组装成一整个maindata。|改为分别stuffing。|
|短块编码有误。|part2长度计算有误，导致短块的比特流组装有误。|改进part2长度计算。|
|静音granule（指频谱全为0的granule）出现很大的超限。|因静音帧经过内层循环后得到的`globalGain`为210（因为SFM=1并且量化步数=0），这是一个很大的增益。|判断哈夫曼编码串的长度是否为0，如果是0，则将`globalGain`设为0。（此为权宜之计，按照IS推荐流程，静音granule其实根本不需要走量化循环）|
