# C.1.3 分析子带滤波器

编码器使用**分析子带滤波器组**（analysis subband filterbank）将采样率为$f_s$的“宽带”音频信号划分为32个子带，子带信号的采样率相应地降为$f_s/32$。图C.4给出了分析子带滤波器的算法流程图，以及算法中所使用的公式。该算法包括以下几个步骤：

- 输入32个音频采样。
- 构建由512个采样组成的输入缓冲区X。刚输入的32个采样被移动到缓冲区的[0,32)位置上，其中最新的输入采样位于缓冲区位置0，而最旧的32个采样被移出缓冲区。（**注：这可以理解成一个512点的窗口从左向右滑过样本，每次滑动步进32点。窗口最右侧为0，最左侧为511，与输入序列顺序相反。窗口最右侧为实际的输入，其左侧为缓冲区。见下面的字符图。**）

```
音频采样| 0 1 ... X    X   ... X   X  ... X  X ...
输入缓冲|        [511  510 ... 32  31 ... 1  0]→（每次右移32点）
实际输入|                         [-----------]
```

- 使用向量C对输入缓冲X加窗。C各点系数在表C.1中定义。
- 根据流程图，计算64点的向量Y。
- 根据流程图，计算分别归属于32个子带的（在当前输入窗口所在时刻降采样的）采样值。其中$M_{ik} = \cos((2i + 1)(k - 16) \pi / 64)$，式中i∈[0,32)，k∈[0,64)。
