# C.1.5.3 编码/第Ⅲ层的编码

## 1 介绍

本章描述第三层的一种可能的编码方法，其基本数据流已经在一般化的心理声学编码器框图中描述。

## 2 心理声学模型

心理声学模型参数可以使用第一模型或第二模型去计算，下文描述的是第二模型应用在第三层编码中所做的一些改动。每个块block都会跑两次心理声学模型，使用576样本的位移长度。

### 2.1 第二心理声学模型在第三层编码中的改动

**模型通用部分的变动**：

模型会被并行地计算两次。其中一次用于短块，iblen=192，FFT长度=256。另一次用于长块，iblen=576，FFT长度=1024。

**不可预测度算法的变化**：

仅计算前206条谱线的cw，其余谱线的cw设定为0.4定值。

前6条谱线（0～5）的cw由长块FFT的结果计算，6～205谱线的cw由短块FFT的结果计算。

cw(w) = 公式

式中cw_l是长块FFT计算得到的不可预测度，cw_s是使用帧分节（granule）中第二个短块（192点）的FFT结果计算得到的不可预测度。

**扩散函数的变化**：

tmpy重定义

小于1e-6的函数值一律设为0。

框图C.6.b中引入了参数conv1=-0.299，conv2=-0.43。

参数NMT（noise masking tone）对每个**阈值计算区间TCP**（threshold calculating partion）均设为6.0dB。TMN（tone masking noise）均设为29.0dB。

**阈值计算分区**的具体数据，包括参数minval见表C.7。

心理声学熵可由thr/eb比值计算得到，其中thr是模型计算出的阈值（见图C.6.a/b），eb_k是阈值计算区间k的能量。

前回声控制：框图C.6.b引入两个参数rpelev和rpelev2。

阈值不会在FFT谱线之间扩散。阈值计算区间将直接转换到**尺度因子频带SFB**（见图C.6.c）。（根据图C.6.c的算法），参与尺度因子频带计算的第一个阈值计算区间需要乘以权值w1，最后一个乘以阈值w2。具体值见表C.8。该表还包括每个尺度因子频带需要使用的阈值计算区间的数量cbw（不含第一个和最后一个阈值计算区间）。参数bo和bu也在表C.8中给出。

短块的阈值计算（SNR为常数）采用相对简化的算法，表C.7.d/e/f给出了相应的SNR值。

- 表C.7 阈值计算区间TCP（按长短块和采样率分表）
- 表C.8 阈值计算区间TCP与尺度因子频带SFB的转换（按长短块和采样率分表）

- 图C.6 第三层使用的第二心理声学模型算法框图

**窗口切换**：

滤波器组依据心理声学熵PE的计算结果决定是否进行窗口切换。若PE>1800（所谓的attack），则触发窗口切换。